searchNodes=[{"doc":"Fast &amp; concurrent probabilistic data structures built on top of :atomics with concurrent accessibility . Talan.BloomFilter - bloom filter based on :atomics Talan.CountingBloomFilter - counting bloom filter based on :atomics Talan.Counter - linear probabilistic counter based on :atomics","ref":"Talan.html","title":"Talan","type":"module"},{"doc":"Bloom filter implementation with concurrent accessibility , powered by :atomics module. &quot;A Bloom filter is a space-efficient probabilistic data structure, conceived by Burton Howard Bloom in 1970, that is used to test whether an element is a member of a set&quot; Bloom filter on Wikipedia Credit Partly inspired by Blex Features Fixed size Bloom filter Concurrent reads &amp; writes Custom &amp; default hash functions Merge multiple Bloom filters into one Intersect multiple Bloom filters into one Estimate number of unique elements Estimate current false positive probability Examples iex&gt; b = Talan.BloomFilter . new ( 1000 ) iex&gt; b |&gt; Talan.BloomFilter . put ( &quot;Barna&quot; ) iex&gt; b |&gt; Talan.BloomFilter . member? ( &quot;Barna&quot; ) true iex&gt; b |&gt; Talan.BloomFilter . member? ( &quot;Kovacs&quot; ) false","ref":"Talan.BloomFilter.html","title":"Talan.BloomFilter","type":"module"},{"doc":"Returns a map representing the bit state of the atomics_ref . Use this for debugging purposes. Examples iex&gt; b = Talan.BloomFilter . new ( 1000 ) iex&gt; b |&gt; Talan.BloomFilter . bits_info ( ) %{ total_bits : 9536 , set_bits_count : 0 , set_ratio : 0.0 }","ref":"Talan.BloomFilter.html#bits_info/1","title":"Talan.BloomFilter.bits_info/1","type":"function"},{"doc":"Returns an non negative integer representing the estimated cardinality count of unique elements in the filter. Examples iex&gt; b = Talan.BloomFilter . new ( 1000 ) iex&gt; b |&gt; Talan.BloomFilter . cardinality ( ) 0 iex&gt; b |&gt; Talan.BloomFilter . put ( &quot;Barna&quot; ) iex&gt; b |&gt; Talan.BloomFilter . cardinality ( ) 1 iex&gt; b |&gt; Talan.BloomFilter . put ( &quot;Barna&quot; ) iex&gt; b |&gt; Talan.BloomFilter . cardinality ( ) 1 iex&gt; b |&gt; Talan.BloomFilter . put ( &quot;Kovacs&quot; ) iex&gt; b |&gt; Talan.BloomFilter . cardinality ( ) 2","ref":"Talan.BloomFilter.html#cardinality/1","title":"Talan.BloomFilter.cardinality/1","type":"function"},{"doc":"Returns a float representing current estimated false positivity probability. Examples iex&gt; b = Talan.BloomFilter . new ( 1000 ) iex&gt; b |&gt; Talan.BloomFilter . false_positive_probability ( ) 0.0 # fpp zero when bloom filter is empty iex&gt; b |&gt; Talan.BloomFilter . put ( &quot;Barna&quot; ) # fpp increase iex&gt; b |&gt; Talan.BloomFilter . put ( &quot;Kovacs&quot; ) iex&gt; fpp = b |&gt; Talan.BloomFilter . false_positive_probability ( ) iex&gt; fpp &gt; 0 &amp;&amp; fpp &lt; 1 true","ref":"Talan.BloomFilter.html#false_positive_probability/1","title":"Talan.BloomFilter.false_positive_probability/1","type":"function"},{"doc":"Hashes term with all hash_functions of %Talan.BloomFilter{} . Returns a list of hashed values. Examples b = Talan.BloomFilter . new ( 1000 ) Talan.BloomFilter . hash_term ( b , :any_term_can_be_hashed ) [ 9386 , 8954 , 8645 , 4068 , 5445 , 6914 , 2844 ]","ref":"Talan.BloomFilter.html#hash_term/2","title":"Talan.BloomFilter.hash_term/2","type":"function"},{"doc":"Intersection of %Talan.BloomFilter{} structs's atomics into one new struct. Note: To work correctly filters with identical size &amp; hash functions must be used. Returns a new %BloomFilter{} struct which set bits are the intersection the bloom filters in the list . Examples iex&gt; hash_functions = Talan . seed_n_murmur_hash_fun ( 7 ) iex&gt; b1 = Talan.BloomFilter . new ( 1000 , hash_functions : hash_functions ) iex&gt; b1 |&gt; Talan.BloomFilter . put ( &quot;GitHub&quot; ) iex&gt; b2 = Talan.BloomFilter . new ( 1000 , hash_functions : hash_functions ) iex&gt; b2 |&gt; Talan.BloomFilter . put ( &quot;GitHub&quot; ) iex&gt; b2 |&gt; Talan.BloomFilter . put ( &quot;Octocat&quot; ) :ok iex&gt; b3 = Talan.BloomFilter . intersection ( [ b1 , b2 ] ) iex&gt; b3 |&gt; Talan.BloomFilter . member? ( &quot;GitHub&quot; ) true iex&gt; b3 |&gt; Talan.BloomFilter . member? ( &quot;Octocat&quot; ) false","ref":"Talan.BloomFilter.html#intersection/1","title":"Talan.BloomFilter.intersection/1","type":"function"},{"doc":"Checks for membership of term in bloom_filter . Returns false if not a member. (definitely not member) Returns true if maybe a member. (possibly member) Examples iex&gt; b = Talan.BloomFilter . new ( 1000 ) iex&gt; b |&gt; Talan.BloomFilter . member? ( &quot;Barna Kovacs&quot; ) false iex&gt; b |&gt; Talan.BloomFilter . put ( &quot;Barna Kovacs&quot; ) iex&gt; b |&gt; Talan.BloomFilter . member? ( &quot;Barna Kovacs&quot; ) true","ref":"Talan.BloomFilter.html#member?/2","title":"Talan.BloomFilter.member?/2","type":"function"},{"doc":"Merge multiple %Talan.BloomFilter{} structs's atomics into one new struct. Note: To work correctly filters with identical size &amp; hash functions must be used. Returns a new %Talan.BloomFilter{} struct which set bits are the merged set bits of the bloom filters in the list . Examples iex&gt; hash_functions = Talan . seed_n_murmur_hash_fun ( 7 ) iex&gt; b1 = Talan.BloomFilter . new ( 1000 , hash_functions : hash_functions ) iex&gt; b1 |&gt; Talan.BloomFilter . put ( &quot;GitHub&quot; ) iex&gt; b2 = Talan.BloomFilter . new ( 1000 , hash_functions : hash_functions ) iex&gt; b2 |&gt; Talan.BloomFilter . put ( &quot;Octocat&quot; ) :ok iex&gt; b3 = Talan.BloomFilter . merge ( [ b1 , b2 ] ) iex&gt; b3 |&gt; Talan.BloomFilter . member? ( &quot;GitHub&quot; ) true iex&gt; b3 |&gt; Talan.BloomFilter . member? ( &quot;Octocat&quot; ) true","ref":"Talan.BloomFilter.html#merge/1","title":"Talan.BloomFilter.merge/1","type":"function"},{"doc":"Returns a new %Talan.BloomFilter{} for the desired cardinality . cardinality is the expected number of unique items. Duplicated items can be infinite. Options :false_positive_probability - a float, defaults to 0.01 :hash_functions - a list of hash functions, defaults to randomly seeded murmur Examples iex&gt; bloom_filter = Talan.BloomFilter . new ( 1_000_000 ) iex&gt; bloom_filter |&gt; Talan.BloomFilter . put ( &quot;Barna Kovacs&quot; ) :ok","ref":"Talan.BloomFilter.html#new/2","title":"Talan.BloomFilter.new/2","type":"function"},{"doc":"Puts term into bloom_filter a %Talan.BloomFilter{} struct. After this the member? function will always return true for the membership of term . Returns :ok . Examples iex&gt; b = Talan.BloomFilter . new ( 1000 ) iex&gt; b |&gt; Talan.BloomFilter . put ( &quot;Chris McCord&quot; ) :ok iex&gt; b |&gt; Talan.BloomFilter . put ( &quot;Jose Valim&quot; ) :ok","ref":"Talan.BloomFilter.html#put/2","title":"Talan.BloomFilter.put/2","type":"function"},{"doc":"Returns the required bit count given cardinality - Number of unique elements that will be inserted false_positive_probability - Desired false positive probability of membership Wikipedia - Bloom filter - Optimal number of hash functions Examples iex&gt; Talan.BloomFilter . required_filter_length ( 10_000 , 0.01 ) 95851","ref":"Talan.BloomFilter.html#required_filter_length/2","title":"Talan.BloomFilter.required_filter_length/2","type":"function"},{"doc":"Returns count of required hash functions for the given false_positive_probability . Wikipedia - Bloom filter - Optimal number of hash functions Examples iex&gt; Talan.BloomFilter . required_hash_function_count ( 0.01 ) 7 iex&gt; Talan.BloomFilter . required_hash_function_count ( 0.001 ) 10 iex&gt; Talan.BloomFilter . required_hash_function_count ( 0.0001 ) 14","ref":"Talan.BloomFilter.html#required_hash_function_count/1","title":"Talan.BloomFilter.required_hash_function_count/1","type":"function"},{"doc":"","ref":"Talan.BloomFilter.html#t:t/0","title":"Talan.BloomFilter.t/0","type":"type"},{"doc":"Linear probabilistic counter implementation with concurrent accessibility , powered by :atomics module for cardinality estimation. Cardinality is the count of unique elements. For more info about linear probabilistic counting: linear probabilistic counting","ref":"Talan.Counter.html","title":"Talan.Counter","type":"module"},{"doc":"Returns the estimated cardinality for the given %Talan.Counter{} struct. Examples iex&gt; c = Talan.Counter . new ( 10_000 ) iex&gt; c |&gt; Talan.Counter . put ( [ &quot;you&quot; , :can , Hash , { &quot;any&quot; , &quot;elixir&quot; , &quot;term&quot; } ] ) iex&gt; c |&gt; Talan.Counter . put ( [ &quot;you&quot; , :can , Hash , { &quot;any&quot; , &quot;elixir&quot; , &quot;term&quot; } ] ) iex&gt; c |&gt; Talan.Counter . cardinality ( ) 1 iex&gt; c |&gt; Talan.Counter . put ( &quot;more&quot; ) iex&gt; c |&gt; Talan.Counter . cardinality ( ) 2","ref":"Talan.Counter.html#cardinality/1","title":"Talan.Counter.cardinality/1","type":"function"},{"doc":"Returns a new %Talan.Counter{} struct. expected_cardinality is the max number of uniq items the counter will handle with approx 1% of error rate. Options hash_function - defaults to Murmur.hash_x64_128/1 Examples iex&gt; c = Talan.Counter . new ( 10_000 ) iex&gt; c |&gt; Talan.Counter . put ( [ &quot;you&quot; , :can , Hash , { &quot;any&quot; , &quot;elixir&quot; , &quot;term&quot; } ] ) iex&gt; c |&gt; Talan.Counter . put ( &quot;more&quot; ) iex&gt; c |&gt; Talan.Counter . put ( &quot;another&quot; ) iex&gt; c |&gt; Talan.Counter . cardinality ( ) 3","ref":"Talan.Counter.html#new/2","title":"Talan.Counter.new/2","type":"function"},{"doc":"Hashes term and sets a bit to mark it has been seen. Doesn't store the term so it's space efficient. Uses :atomics so it's mutable &amp; highly concurrent. Returns :ok . Examples iex&gt; c = Talan.Counter . new ( 10_000 ) iex&gt; c |&gt; Talan.Counter . put ( [ &quot;you&quot; , :can , Hash , { &quot;any&quot; , &quot;elixir&quot; , &quot;term&quot; } ] ) :ok","ref":"Talan.Counter.html#put/2","title":"Talan.Counter.put/2","type":"function"},{"doc":"","ref":"Talan.Counter.html#t:t/0","title":"Talan.Counter.t/0","type":"type"},{"doc":"Counting bloom filter implementation with concurrent accessibility , powered by :atomics module. Features Fixed size Counting Bloom filter Concurrent reads &amp; writes Custom &amp; default hash functions Estimate number of unique elements Estimate false positive probability Counting bloom filters support probabilistic deletion of elements but have higher memory consumption because they need to store a counter of N bits for every bloom filter bit.","ref":"Talan.CountingBloomFilter.html","title":"Talan.CountingBloomFilter","type":"module"},{"doc":"See Talan.BloomFilter.cardinality/1 for docs. Examples iex&gt; cbf = Talan.CountingBloomFilter . new ( 10_000 ) iex&gt; cbf |&gt; Talan.CountingBloomFilter . put ( &quot;hat&quot; ) iex&gt; cbf |&gt; Talan.CountingBloomFilter . put ( &quot;hat&quot; ) iex&gt; cbf |&gt; Talan.CountingBloomFilter . put ( &quot;hat&quot; ) iex&gt; cbf |&gt; Talan.CountingBloomFilter . put ( &quot;car keys&quot; ) iex&gt; cbf |&gt; Talan.CountingBloomFilter . cardinality ( ) 2","ref":"Talan.CountingBloomFilter.html#cardinality/1","title":"Talan.CountingBloomFilter.cardinality/1","type":"function"},{"doc":"Returns probabilistic count of term in counter . This means that (given no hash collisions) it returns how many times the item was put into the CountingBloomFilter. A few hash collisions should be also fine since it returns the average count of the counters. An single item is hashed with multiple counters. Examples iex&gt; cbf = Talan.CountingBloomFilter . new ( 10_000 ) iex&gt; cbf |&gt; Talan.CountingBloomFilter . put ( &quot;hat&quot; ) iex&gt; cbf |&gt; Talan.CountingBloomFilter . put ( &quot;hat&quot; ) iex&gt; cbf |&gt; Talan.CountingBloomFilter . put ( &quot;hat&quot; ) iex&gt; cbf |&gt; Talan.CountingBloomFilter . count ( &quot;hat&quot; ) 3","ref":"Talan.CountingBloomFilter.html#count/2","title":"Talan.CountingBloomFilter.count/2","type":"function"},{"doc":"Probabilistically delete term from bloom_filter and decrement counters in counter . Examples iex&gt; cbf = Talan.CountingBloomFilter . new ( 10_000 ) iex&gt; cbf |&gt; Talan.CountingBloomFilter . put ( &quot;hat&quot; ) iex&gt; cbf |&gt; Talan.CountingBloomFilter . count ( &quot;hat&quot; ) 1 iex&gt; cbf |&gt; Talan.CountingBloomFilter . delete ( &quot;hat&quot; ) :ok iex&gt; cbf |&gt; Talan.CountingBloomFilter . count ( &quot;hat&quot; ) 0 iex&gt; cbf |&gt; Talan.CountingBloomFilter . delete ( &quot;this wasn&#39;t there&quot; ) iex&gt; cbf |&gt; Talan.CountingBloomFilter . count ( &quot;this wasn&#39;t there&quot; ) - 1","ref":"Talan.CountingBloomFilter.html#delete/2","title":"Talan.CountingBloomFilter.delete/2","type":"function"},{"doc":"See Talan.BloomFilter.false_positive_probability/1 for docs.","ref":"Talan.CountingBloomFilter.html#false_positive_probability/1","title":"Talan.CountingBloomFilter.false_positive_probability/1","type":"function"},{"doc":"See Talan.BloomFilter.member?/2 for docs. Examples iex&gt; cbf = Talan.CountingBloomFilter . new ( 10_000 ) iex&gt; cbf |&gt; Talan.CountingBloomFilter . put ( &quot;hat&quot; ) iex&gt; cbf |&gt; Talan.CountingBloomFilter . member? ( &quot;hat&quot; ) true","ref":"Talan.CountingBloomFilter.html#member?/2","title":"Talan.CountingBloomFilter.member?/2","type":"function"},{"doc":"Returns a new %Talan.CountingBloomFilter{} struct. cardinality is the expected number of unique items. Duplicated items can be infinite. Options :counters_bit_size - bit size of counters, defaults to 8 :signed - to have signed or unsigned counters, defaults to true :false_positive_probability - a float, defaults to 0.01 :hash_functions - a list of hash functions, defaults to randomly seeded murmur Examples iex&gt; cbf = Talan.CountingBloomFilter . new ( 10_000 ) iex&gt; cbf |&gt; Talan.CountingBloomFilter . put ( &quot;hat&quot; ) iex&gt; cbf |&gt; Talan.CountingBloomFilter . put ( &quot;hat&quot; ) iex&gt; cbf |&gt; Talan.CountingBloomFilter . put ( &quot;phone&quot; ) :ok iex&gt; cbf |&gt; Talan.CountingBloomFilter . count ( &quot;hat&quot; ) 2 iex&gt; cbf |&gt; Talan.CountingBloomFilter . count ( &quot;phone&quot; ) 1","ref":"Talan.CountingBloomFilter.html#new/2","title":"Talan.CountingBloomFilter.new/2","type":"function"},{"doc":"Puts term into bloom_filter and increments counters in counter . After this the member?/2 function will return true for the membership of term unless bits representing membership are modified by the delete/2 function. Returns :ok . Examples iex&gt; cbf = Talan.CountingBloomFilter . new ( 10_000 ) iex&gt; cbf |&gt; Talan.CountingBloomFilter . put ( &quot;hat&quot; ) :ok","ref":"Talan.CountingBloomFilter.html#put/2","title":"Talan.CountingBloomFilter.put/2","type":"function"},{"doc":"","ref":"Talan.CountingBloomFilter.html#t:t/0","title":"Talan.CountingBloomFilter.t/0","type":"type"},{"doc":"","ref":"Talan.Stream.html","title":"Talan.Stream","type":"module"},{"doc":"Returns a probabilistically uniq stream. Its main advantage is that it doesn't store elements emitted by the stream. Instead it uses a bloom filter for membership check. The stream never returns duplicate elements but it sometimes detects false positive duplicates depending on the bloom filter it uses. False positives are faulty duplicate detections that get rejected. Examples iex&gt; list = [ &quot;a&quot; , &quot;b&quot; , &quot;c&quot; , &quot;a&quot; , &quot;b&quot; ] iex&gt; bloom_filter = Talan.BloomFilter . new ( 100_000 , false_positive_probability : 0.001 ) iex&gt; Talan.Stream . uniq ( list , bloom_filter ) |&gt; Enum . to_list [ &quot;a&quot; , &quot;b&quot; , &quot;c&quot; ]","ref":"Talan.Stream.html#uniq/2","title":"Talan.Stream.uniq/2","type":"function"}]